function [etap,s_eta,h,eta_1,seps]=estimate_shocks(z,eps,neta1,seps)

%% Shock Estimatio
[eta_1,lmbd]=est_eta(z,eps,neta1);
%%
nfac=cols(eps);
tmp=packr([eta_1 eps]);
yp=tmp(:,1:cols(eta_1));
xp=tmp(:,cols(eta_1)+1:cols(eta_1)+nfac);
bp=xp\yp;
hinv = zeros(nfac,nfac);      % eta(t) = hinv*eps(t) 
hinv(1:cols(eta_1),:)=bp';    % First rows yield eta_1 
% Find Other rows so that eta_2 is uncorrelated with eta_1 
tmp=eye(nfac)-bp*invpd(bp'*bp)*bp';
[va,ve]=eighv(tmp,'NotFlip');
bp_perp = ve(:,cols(bp)+1:nfac);
 seps=cov(eps);
sxx = bp'*seps*bp;
sxy = bp'*seps*bp_perp;
hinv(cols(eta_1)+1:nfac,:)=bp_perp'-sxy'*invpd(sxx)*bp';
h = inv(hinv);
eta = eps*hinv';
% Normalize ETA to have unit standard Deviation 
etap = packr(eta);
s_eta = std(etap);
eta = etap./kron(ones(size(eta,1),1),s_eta);
h = h.*kron(ones(size(h,1),1),s_eta);