
function [out,PROBLEM]=likelihood(theta,y)
PROBLEM=0;
N=length(theta);
N1=N-3;  %last 3 elements of theta are standard deviation of shocks
t=size(y,1);

%model solution to obtain state space form
 [ GAM0, GAM1,C, PSI, PPI, A1_1, B1_1, A2_1,B2_1, H, modinfo] = modelJPshortH(theta);
     [G1,C,impact,fmat,fwt,ywt,gev,eu]=gensys(GAM0,GAM1,C,PSI,PPI);
     
      neq  = length(fieldnames(modinfo.eq));
neps = length(fieldnames(modinfo.e));
neta = length(fieldnames(modinfo.n));
 G1      = G1(1:neq-neta,1:neq-neta);
impact  = impact(1:neq-neta,:);

Sigma=diag(theta(N1+1:end));
F=G1;
QQ=impact;

if eu(1)~=1 | eu(2)~=1  % non-unique and existence
    PROBLEM=1;
end

if PROBLEM
    out=-10000000;
else


Q=QQ*Sigma*QQ';
mu=0;

lik=0;
%filter
ns=size(G1,1);
beta0=zeros(1,ns);
p00=eye(ns);
ptt=zeros(t,ns,ns);
i=1;
r=0;
%Prediction
beta10=mu+beta0*F';
p10=F*p00*F'+Q;
yhat=(H*(beta10)')';                                                
eta=y(i,:)-yhat;
feta=(H*p10*H')+r;
%updating
if rcond(feta)<=1e-10 || isnan(rcond(feta));
    PROBLEM=1;
        out=-100000000;
        return;
end
K=(p10*H')*inv(feta);
beta11=(beta10'+K*eta')';
p11=p10-K*(H*p10);
% beta_tt=[beta_tt;beta11];
ptt(i,:,:)=p11;

for i=2:t
    %Prediction
beta10=mu+beta11*F';
p10=F*p11*F'+Q;
yhat=(H*(beta10)')';                                                
eta=y(i,:)-yhat;
feta=(H*p10*H')+r;
%updating
if rcond(feta)<=1e-10 || isnan(rcond(feta));
    PROBLEM=1;
        out=-100000000;
        return;
end
K=(p10*H')*inv(feta);
beta11=(beta10'+K*eta')';
p11=p10-K*(H*p10);
ptt(i,:,:)=p11;

liki=-0.5*log(2*pi)-0.5*log(det(feta))+(-0.5*(eta)*inv(feta)*(eta'));

if isreal(liki) & (1-isinf(liki))
    lik=lik+liki;
else
    lik=lik-10;
end

end
out=lik;
end

