function fsave=runcholvar4(data,L,lamdaP,REPS,BURN,HORZ);

Y=data;
N=cols(Y);
%take lags
X=[];
for j=1:L
X=[X lag0(data,j) ];
end
X=[X ones(rows(X),1)];
Y=Y(L+1:end,:);
X=X(L+1:end,:);

% Additional priors for VAR coefficients
muP=mean(Y)';
sigmaP=[];
deltaP=[];
e0=[];
for i=1:N
    ytemp=Y(:,i);
    xtemp=[lag0(ytemp,1) ones(rows(ytemp),1)];
    ytemp=ytemp(2:end,:);
    xtemp=xtemp(2:end,:);
    btemp=xtemp\ytemp;
    etemp=ytemp-xtemp*btemp;
    stemp=etemp'*etemp/rows(ytemp);
    if abs(btemp(1))>1
        btemp(1)=1;
    end
    deltaP=[deltaP;btemp(1)];
    sigmaP=[sigmaP;stemp];
    e0=[e0 etemp];
end
tauP=lamdaP*10;
epsilonP=1/10000;
%dummy data to implement priors see http://ideas.repec.org/p/ecb/ecbwps/20080966.html
[yd,xd] = create_dummies(lamdaP,tauP,deltaP,epsilonP,L,muP,sigmaP,N);


T=rows(Y);
fsave=zeros(REPS-BURN,HORZ,N); 
jgibbs=1;

Y0=[Y;yd];
  X0=[X;xd];
  %conditional mean of the VAR coefficients
  mstar=vec(X0\Y0);  %ols on the appended data
  xx=X0'*X0;
  ixx=xx\eye(cols(xx));  %inv(X0'X0) to be used later in the Gibbs sampling algorithm
  sigma=eye(N); %starting value for sigma
  beta0=vec(X0\Y0);
  igibbs=1;
  jgibbs=0;
  MaxTrys=1000;
while jgibbs<REPS-BURN
	
    
    
     %step 1: Sample VAR coefficients
     [ beta2,PROBLEM] = getcoef( mstar,sigma,ixx,MaxTrys,N,L );
     if PROBLEM
         beta2=beta0;
     else
         beta0=beta2;
     end
     
     %draw covariance
     e=Y0-X0*reshape(beta2,N*L+1,N);
    scale=e'*e;
    sigma=iwpq(T+rows(yd),inv(scale));

     if igibbs>BURN && ~PROBLEM
         jgibbs=jgibbs+1;
        A0=chol(sigma);
         yhat = irfsim(reshape(beta2,N*L+1,N),N,L,A0,[0 0 0 1],HORZ);
         
       % size(yhat)
         fsave(jgibbs,:,:)=yhat(1:end,:);
         
         
     end
     igibbs=igibbs+1;
end



end


