function fsave=runsignvar1(data,L,lamdaP,REPS,BURN,HORZ);

Y=data;
N=cols(Y);
%take lags
X=[];
for j=1:L
X=[X lag0(data,j) ];
end
X=[X ones(rows(X),1)];
Y=Y(L+1:end,:);
X=X(L+1:end,:);

% Additional priors for VAR coefficients
muP=mean(Y)';
sigmaP=[];
deltaP=[];
e0=[];
for i=1:N
    ytemp=Y(:,i);
    xtemp=[lag0(ytemp,1) ones(rows(ytemp),1)];
    ytemp=ytemp(2:end,:);
    xtemp=xtemp(2:end,:);
    btemp=xtemp\ytemp;
    etemp=ytemp-xtemp*btemp;
    stemp=etemp'*etemp/rows(ytemp);
    if abs(btemp(1))>1
        btemp(1)=1;
    end
    deltaP=[deltaP;btemp(1)];
    sigmaP=[sigmaP;stemp];
    e0=[e0 etemp];
end
tauP=lamdaP*10;
epsilonP=1/10000;
%dummy data to implement priors see http://ideas.repec.org/p/ecb/ecbwps/20080966.html
[yd,xd] = create_dummies(lamdaP,tauP,deltaP,epsilonP,L,muP,sigmaP,N);


T=rows(Y);
fsave=zeros(REPS-BURN,HORZ,N); 
jgibbs=1;

Y0=[Y;yd];
  X0=[X;xd];
  %conditional mean of the VAR coefficients
  mstar=vec(X0\Y0);  %ols on the appended data
  xx=X0'*X0;
  ixx=xx\eye(cols(xx));  %inv(X0'X0) to be used later in the Gibbs sampling algorithm
  sigma=eye(N); %starting value for sigma
  beta0=vec(X0\Y0);
  igibbs=1;
  jgibbs=0;
  MaxTrys=1000;
while jgibbs<REPS-BURN
	
    
    
     %step 1: Sample VAR coefficients
     [ beta2,PROBLEM] = getcoef( mstar,sigma,ixx,MaxTrys,N,L );
     if PROBLEM
         beta2=beta0;
     else
         beta0=beta2;
     end
     
     %draw covariance
     e=Y0-X0*reshape(beta2,N*L+1,N);
    scale=e'*e;
    sigma=iwpq(T+rows(yd),inv(scale));

     if igibbs>BURN && ~PROBLEM
         jgibbs=jgibbs+1;
        
         A0hat=chol(sigma);
         A0big=[];
        for M=1:500
        %impose sign restrictions
        
        %impose sign restrictions
        chck=-1;
        while chck<0
        K=randn(N,N);
        Q=getQR(K);
       
        A0hat1=(Q*A0hat);  %candidate draw
        for m=1:N
        %check signs in each row
        e1=A0hat1(m,1)<0;  %Response of Y
        e2=A0hat1(m,2)<0;  %Response of P
        e3=A0hat1(m,3)>0;  %Response of R
        
        if e1+e2+e3==3
            MP=A0hat1(m,:);
            chck=10;
        else
            %check signs but reverse them
        e1=-A0hat1(m,1)<0;  %Response of Y
        e2=-A0hat1(m,2)<0;  %Response of P
        e3=-A0hat1(m,3)>0;  %Response of R
        if e1+e2+e3==3
            MP=-A0hat1(m,:);
            chck=10;
        end
        end
        end
        end
        %re-shuffle rows of A0hat1 and insert MP in the first row
        A0x=[]; %will hold rows of A0hat1 not equal to MP
        for m=1:N
            ee=sum(abs(A0hat1(m,:))==abs(MP));
            if ee==0
                A0x=[A0x;A0hat1(m,:)];
            end
        end
        A0new=[A0x;MP]; %A0 matrix to be used for impulse response
        
        A0big=[A0big;vec(A0new)'];
        end
        
        MA0=median(A0big); %find the median
        DIFFA0=sum((A0big-repmat(MA0,500,1)).^2,2); %distance from the median
        [~,id]=min(DIFFA0);
        A0NEW=reshape(A0big(id,:),N,N); %this is the A0 matrix closest to the median
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
%         A0NEW'*A0NEW-sigma
        
        
         yhat = irfsim(reshape(beta2,N*L+1,N),N,L,A0NEW,[0 0 1],HORZ);
       % size(yhat)
         fsave(jgibbs,:,:)=yhat(1:end,:);
         
         
     end
     igibbs=igibbs+1;
end



end


