clear;
clc
addpath('functions');
datac=xlsread('data_avol_m3.xlsx');
measures=xlsread('measures.xlsx');
measures=[datac(:,end) measures];
L=12;       %number of lags
HORZ=36;    %number of periods to compute the impulse response for
Bootstrap=1;   % 1 if error bands are to be produced
Reps=10;      % Number of replications for bootstrap




%Estimate proxy VAR                                %Variables in the VAR %Instrument
[ m3save1,m3saveL,m3saveH,m3fevd,m3base,m3hd,VAR01 ] = runproxyvar( datac(:,1:end-1),measures(:,1),L,HORZ,Bootstrap,Reps );

[ m3save2,m3saveL2,m3saveH2,m3fevd2,m3base2,m3hd2,VAR012 ] = runproxyvar( datac(:,1:end-1),measures(:,2),L,HORZ,Bootstrap,Reps );

[ m3save3,m3saveL3,m3saveH3,m3fevd3,m3base3,m3hd3,VAR013 ] = runproxyvar( datac(:,1:end-1),measures(:,3),L,HORZ,Bootstrap,Reps );


[ m3save4,m3saveL4,m3saveH4,m3fevd4,m3base4,m3hd4,VAR014 ] = runproxyvar( datac(:,1:end-1),measures(:,4),L,HORZ,Bootstrap,Reps );

[ m3save5,m3saveL5,m3saveH5,m3fevd5,m3base5,m3hd5,VAR015 ] = runproxyvar( datac(:,1:end-1),measures(:,5),L,HORZ,Bootstrap,Reps );

figure(1)
HORZ=36;
HH=0:HORZ-1;
subplot(4,2,2)
plotr(HH,[m3save1(:,1) m3save2(:,1) m3save3(:,1) m3save4(:,1) m3save5(:,1)]*15);
axis tight
title('Volatility Indicator');
xlabel('Horizon')
subplot(4,2,1)
plotr(HH,[m3save1(:,2) m3save2(:,2) m3save3(:,2) m3save4(:,2) m3save5(:,2)]*1500);
axis tight
title('Stock Price Index');
xlabel('Horizon')

subplot(4,2,3)
plotr(HH,[m3save1(:,3) m3save2(:,3) m3save3(:,3) m3save4(:,3) m3save5(:,3)]*15);
axis tight
title('FFR');
xlabel('Horizon')


subplot(4,2,4)
plotr(HH,[m3save1(:,4) m3save2(:,4) m3save3(:,4) m3save4(:,4) m3save5(:,4)]*1500);
axis tight
title('Wages');
xlabel('Horizon')


subplot(4,2,5)
plotr(HH,[m3save1(:,5) m3save2(:,5) m3save3(:,5) m3save4(:,5) m3save5(:,5)]*1500);
axis tight
title('CPI');
xlabel('Horizon')


subplot(4,2,6)
plotr(HH,[m3save1(:,6) m3save2(:,6) m3save3(:,6) m3save4(:,6) m3save5(:,6)]*1500);
axis tight
title('Hours');
xlabel('Horizon')


subplot(4,2,7)
plotr(HH,[m3save1(:,7) m3save2(:,7) m3save3(:,7) m3save4(:,7) m3save5(:,7)]*1500);
axis tight
title('Employment');
xlabel('Horizon')


subplot(4,2,8)
plotr(HH,[m3save1(:,8) m3save2(:,8) m3save3(:,8) m3save4(:,8) m3save5(:,8)]*1500);
axis tight
title('Industrial Production');
xlabel('Horizon')

legend('M1=benchmark','M2=first month timing','M3=oil and terror','M4=Scaled by shock size');


