function yfd = histdecomp(G, Q, H, y)
% historical decomposition of shocks

[ns nshk] = size(Q);
nobs      = size(H,1);
T = length(y);

[x0T,xtT,sterr] = kfks(H,G,zeros(nobs,nobs), Q, y);
sterr = sterr';

xf = zeros(ns,T);
yf = zeros(nobs,T);
xfd = zeros(ns,T,nshk);
yfd = zeros(nobs,T,nshk);

for i = 1 : size(sterr,2);
    if i == 1;
        xf(:,i) = Q * sterr(:,i);
        yf(:,i) = H * xf(:,i);
        for j = 1 : size(Q,2);
            xfd(:,i,j) = Q(:,j) * sterr(j,i);
            yfd(:,i,j) = H * xfd(:,i,j);
        end;
    else
        xf(:,i) = G * xf(:,i-1) + Q * sterr(:,i);
        yf(:,i) = H * xf(:,i);
        for j = 1 : size(Q,2);
            xfd(:,i,j) = G * xfd(:,i-1,j) + Q(:,j) * sterr(j,i);
            yfd(:,i,j) = H * xfd(:,i,j);
        end;
    end;
end;

yfd = permute(yfd,[1 3 2]);