clear;
clc
addpath('functions');
datac=xlsread('data_avol_m3.xlsx');
datac1=xlsread('data_avol_m3M2.xlsx');
datac2=xlsread('data_avol_m3M3.xlsx');

tempy=datac(:,1);
tempx=datac1(:,1);
tempx=(tempx-mean(tempx))./std(tempx);
volm=(tempx.*std(tempy))+mean(tempy);
datac1=[volm datac1(:,2:end)];

tempy=datac(:,1);
tempx=datac2(:,1);
tempx=(tempx-mean(tempx))./std(tempx);
volm1=(tempx.*std(tempy))+mean(tempy);
datac2=[volm1 datac2(:,2:end)];
datac2=datac2(12:end,:);
L=12;       %number of lags
HORZ=36;    %number of periods to compute the impulse response for
Bootstrap=1;   % 1 if error bands are to be produced
Reps=10;      % Number of replications for bootstrap




%Estimate proxy VAR                                %Variables in the VAR %Instrument
[ m3save1,fsaveL1,fsaveH1,FEVDOUT,BASE,HD,VAR01  ] = runproxyvar( datac(:,1:end-1),datac(:,end),L,HORZ,Bootstrap,Reps );

[ m3save2,fsaveL2,fsaveH2,FEVDOUT,BASE,HD,VAR02  ] = runproxyvar( datac1(:,1:end-1),datac1(:,end),L,HORZ,Bootstrap,Reps );

[ m3save3,fsaveL3,fsaveH3,FEVDOUT,BASE,HD,VAR03  ] = runproxyvar( datac2(:,1:end-1),datac2(:,end),L,HORZ,Bootstrap,Reps );



figure(1)
HORZ=36;
HH=0:HORZ-1;
subplot(4,2,2)
plotr(HH,[m3save1(:,1) m3save2(:,1) m3save3(:,1)]*15);
axis tight
title('Volatility Indicator','Fontname','TimesNewRoman','FontSize',14)
xlabel('Horizon','Fontname','TimesNewRoman','FontSize',12)
subplot(4,2,1)
plotr(HH,[m3save1(:,2) m3save2(:,2)  m3save3(:,2)]*1500);
axis tight
title('Stock Price Index','Fontname','TimesNewRoman','FontSize',14);
xlabel('Horizon','Fontname','TimesNewRoman','FontSize',12)
subplot(4,2,3)
plotr(HH,[m3save1(:,3) m3save2(:,3)  m3save3(:,3)]*15);
axis tight
title('Fed Funds Rate','Fontname','TimesNewRoman','FontSize',14)
xlabel('Horizon','Fontname','TimesNewRoman','FontSize',12)

subplot(4,2,4)
plotr(HH,[m3save1(:,4) m3save2(:,4) m3save3(:,4) ]*1500);
axis tight
title('Wage','Fontname','TimesNewRoman','FontSize',14);
xlabel('Horizon','Fontname','TimesNewRoman','FontSize',12)

subplot(4,2,5)
plotr(HH,[m3save1(:,5) m3save2(:,5) m3save3(:,5)]*1500);
axis tight
title('CPI','Fontname','TimesNewRoman','FontSize',14);
xlabel('Horizon','Fontname','TimesNewRoman','FontSize',12)

subplot(4,2,6)
plotr(HH,[m3save1(:,6) m3save2(:,6) m3save3(:,6)]*1500);
axis tight
title('Hours','Fontname','TimesNewRoman','FontSize',14);
xlabel('Horizon','Fontname','TimesNewRoman','FontSize',12)

subplot(4,2,7)
plotr(HH,[m3save1(:,7) m3save2(:,7) m3save3(:,7)]*1500);
axis tight
xlabel('Horizon','Fontname','TimesNewRoman','FontSize',12)

title('Employment','Fontname','TimesNewRoman','FontSize',14);

subplot(4,2,8)
plotr(HH,[m3save1(:,8) m3save2(:,8) m3save3(:,8)]*1500);
axis tight
xlabel('Horizon','Fontname','TimesNewRoman','FontSize',12)
title('Industrial Production','Fontname','TimesNewRoman','FontSize',14);
legend('M1=benchmark','M2=Standard Deviation of daily data','M3=Stochastic Volatility model');



