function UK = loaddata(datadir,xlssheet,subdate1,subdate2,SCALE)

if nargin<5
    SCALE = 1;
end
PPLOT  = 1;
lambda = 1600;
[A,B]               = xlsread(datadir,xlssheet);  % load data
index               = find(sum(isnan(A),2)==0);
UK.name             = B(1,2:end);                                   % name of the series
B                   = B(2:end,1);
Time                = datenum(B(index),'dd/mm/yy');       
Time                = datevec(Time);                                % date for the imported series
UK.date             = Time(:,1:2);                                   
UK.series           = A(index,:);                                            % raw data     
if subdate1~=0
    dataindex1             = max(find(UK.date(2:end,1)==subdate1))+1;
else
    dataindex1 = 1;
end

if subdate2~=0
       dataindex2             = max(find(UK.date(2:end,1)==subdate2))+1;   
else
    dataindex2 = length(UK.date);
end

UK.series           = UK.series(dataindex1:dataindex2,:);

% domestic GDP
UK.trans(:,1)         = log(UK.series(:,1)) ...
                        - hpfilter(log(UK.series(:,1)),lambda);                    


% domestic i
UK.trans(:,3)         = UK.series(:,3)/400;

% domestic pi 
UK.trans(:,2)         = Qdiff(UK.series(:,2));



UK.trans(1,:)         = [];
UK.date               = UK.date(dataindex1+1:dataindex2,1) + UK.date(dataindex1+1:dataindex2,2)/12;
UK.T                  = length(UK.date);
UK.trans              = UK.trans - repmat(mean(UK.trans),UK.T,1);
UK.trans              = SCALE*UK.trans;

UK.name =strvcat('GDP (HP Filtered)', 'Quarterly inflation','Bank Rate');
figure;
if PPLOT
    for i = 1:size(UK.trans,2)
        subplot(2,2,i)
        plot(UK.date,UK.trans(:,i));
        hold on;
        plot(UK.date,zeros(UK.T,1),'k');
        hold off;
        title(UK.name(i,:))
        axis tight;
    end
end

