%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                %
%          MatLab function for vectorizing an mxn matrix         %
%          A column by column                                    %
%                                                                %
%          Function: vec                                         %
%                                                                %
%          Input:                                                %
%                        A: mxn matrix                           %
%                                                                %
%          Output:                                               %
%          		           veca: mnx1 column vectorization of A    %
%                                                                %
%          This version:        November 18, 2004                %
%          Written by: 	        Anders Warne                     %
%                               Copyright (c) 2001-2004          %
%                                                                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function veca = vec(A)

if isempty(A);
   veca = [];
end;

n = size(A,2);

i = 1;
while i<=n;
   if i==1;
      veca = A(:,1);
   else;
      veca = [veca;A(:,i)];
   end;
   i = i+1;
end;

%
% end of function vec.m
%
