function [irf,fsaveL,fsaveH,FEVDOUT,BASE,HD,beta2mean,sigmamean,A0mean,Y0mean,rhovbig]=estimateerrorvar(data,L,REPS,BURN,HORZ,shockcolumn,ucolumn)
MaxTrys=1000;
V0=1;
D0=0.01;
%initial values to initialise lagorithm
Y=data;
N=cols(Y);
%take lags
X=[];
for j=1:L
X=[X lag0(Y,j) ];
end
X=[X ones(rows(X),1)];
Y=Y(L+1:end,:);
X=X(L+1:end,:);

T=rows(Y);

beta2=X\Y;
beta0=vec(beta2);
res=Y-X*beta2;
sigma=(res'*res)/(T-cols(X));
sigmav=[0.1];  %initial value measurement error
rhov=0.5;   %initial value for AR(1) measurement error
rhov0=rhov;
beta2=vec(beta2);
jgibbs=0;
igibbs=1;
beta2mean=0;
sigmamean=0;
Y0mean=0;
while jgibbs<REPS-BURN
%step 1 draw states
H=[eye(N) zeros(N,N*(L-1))];
rhotemp=zeros(1,N);
rhotemp(ucolumn)=-rhov;
H(1:N,N+1:N*2)=diag(rhotemp);
r=zeros(1,N);
r(ucolumn)=sigmav;
R=diag(r);
[F,MU,Q]=comp1(beta2,N,L,sigma);
Ystar1=Y(:,ucolumn)-lag0(Y(:,ucolumn),1)*rhov;
Ystar1(1)=Ystar1(2);
Ystar=Y;
Ystar(:,ucolumn)=Ystar1;
beta2=kcohn(H,R,MU,F,Q,Ystar,L,ucolumn);
Y0=Y;
Y0(:,ucolumn)=beta2(:,ucolumn);
Y0out=Y0;
%step 2 draw measurement error
merror=Y0(:,ucolumn)-Y(:,ucolumn); %serially correlated measurement error
ys=merror;
xs=lag0(ys,1);
ys=ys(2:end,:);
xs=xs(2:end,:);
PROBLEM1=0;
chck=-1;
trys=1;
while chck<0 && trys<MaxTrys;
M=xs\ys;
V=invpd(xs'*xs)*sigmav;
rhov=M+randn(1,1)*sqrt(V);
if abs(V)<=1
    chck=1;
else
    trys=trys+1;
end
end
if chck<0;
    rhov=rhov0;
    PROBLEM1=1;
else
    rhov0=rhov;
end

merror1=ys-xs*rhov;
 sigmav=IG(V0,D0,merror1);
% sigmav=IG(0,0,merror1);

  [rhov sigmav]
%step 3 draw VAR parameters
X0=[];
for j=1:L
X0=[X0 lag0(Y0,j) ];
end
X0=[X0 ones(rows(X0),1)];
Y0=Y0(L+1:end,:);
X0=X0(L+1:end,:);
mstar=vec(X0\Y0);  %ols on the appended data
xx=X0'*X0;
ixx=xx\eye(cols(xx));  %inv(X0'X0) to be used later in the Gibbs sampling algorithm
[ beta2,PROBLEM] = getcoef( mstar,sigma,ixx,MaxTrys,N,L );
     if PROBLEM
         beta2=beta0;
     else
         beta0=beta2;
     end
     
 %draw covariance
     e=Y0-X0*reshape(beta2,N*L+1,N);
    scale=e'*e;
    sigma=iwpq(T,invpd(scale));
    
    if igibbs>BURN && ~PROBLEM && ~PROBLEM1
         jgibbs=jgibbs+1;
         rhovbig(jgibbs,1)=rhov;
         rhovbig(jgibbs,2)=sigmav;
        A0=chol(sigma);
        shock=zeros(1,N);
        shock(shockcolumn)=1;
         yhat = irfsim(reshape(beta2,N*L+1,N),N,L,A0,shock,HORZ);
         sfactor=(1./yhat(1,3))*0.01;

       % size(yhat)
         fsave(jgibbs,:,:)=yhat(1:end,:).*sfactor;%yhat(1:end,:)./yhat(1,shockcolumn);
        beta2mean=beta2mean+beta2;
        sigmamean=sigmamean+sigma; 
        
         Y0mean=Y0mean+Y0out;
    end
     disp(strcat('Iteration=',num2str(igibbs)))
     igibbs=igibbs+1;
end

beta2mean=beta2mean./size(fsave,1);
sigmamean=sigmamean./size(fsave,1);
Y0mean=Y0mean./size(fsave,1);
Y0mean=[Y0mean(1:L,:);Y0mean];
X0mean=[];
for j=1:L
X0mean=[X0mean lag0(Y0mean,j) ];
end
X0mean=[X0mean ones(rows(X0mean),1)];
Y0mean=Y0mean(L+1:end,:);
X0mean=X0mean(L+1:end,:);
A0mean=chol(sigmamean);
resmean=Y0mean-X0mean*reshape(beta2mean,N*L+1,N);
beta2mean1=reshape(beta2mean,N*L+1,N);
FEVDOUT= getfevd( HORZ,N,L,beta2mean1,A0mean );
         %compute Historical decomposition
         
%          [BASE,OUT2,HISTOUT]=historyfast(vec(beta2),A0,res,N,L,T,Y,(1:N)');  
        %code by K Theodoridis
        Aols=[beta2mean1(end,:)' beta2mean1(1:end-1,:)'];
        IdentMat=A0mean';
        datamat=data(1:end,:)';
        errormat=resmean*inv(A0mean);
        const=1;
%         size(datamat)
%         size(errormat)
        DecompVAR=var_historical_decomp(Aols,IdentMat,datamat,...
    errormat(1:end,:)',const);
     BASE=DecompVAR.initeffecty;
     HD=DecompVAR.yfs;

irf=squeeze(median(fsave,1));
fsaveL=squeeze(prctile(fsave,5,1));
fsaveH=squeeze(prctile(fsave,95,1));