function [newTheta] = genTheta(Theta, mean_Theta, var_Theta, npara, bounds)

% genTheta.m
% this function generates new MCMC draws using a normal drawing distribution
% and check against bounds of the model's parameters
% The code comes with no performance guarantees.
% However, if you find this code useful then please cite the paper.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% November 2005: orginal author Philip Liu
%
%==========================================================================
% Input:
%       Theta = previous MCMC draw
%       mean_Theta = mean of the normal drawing distribution
%       var_Theta = variance of the normal drawing distribution
%       npara = is the number of parameters
%       bounds = a (npara x 2) specifying the lower and upper bounds
% (note: you will also need to modify which parameters are to be fixed at
% the end of this function)
%
% Return: 
%       newTheta = new Theta draw that satsfies the constriants
% Calls: 
%       
%==========================================================================
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

lenb=1;
while lenb==1,
newTheta = Theta + normrnd(mean_Theta,var_Theta'); 
%newTheta=Theta+(randn(1,length(Theta))*var_Theta)';
      
    check=sum(newTheta<=bounds(:,1)| newTheta>=bounds(:,2));
    if check ~= 0;
        lenb=1;
    else
        lenb=0;
    end
end

% If you are calibrating certain parameters fix them here. 
newTheta(1) = 0.185;
% newTheta(15) = 5.3661e-004;
% newTheta(4) = 0.19;
% newTheta(13) = 0;
% newTheta(17) = 0;
% newTheta(end) = 0.03;
