close all
//-----------------------------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------------------------
var d A muR sigmaR R pinf y l c mc w margc acp;

varexo dshk Ashk muRshk sigmaRshk;
//-----------------------------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------------------------
parameters csigmac ctheta cepsilon cphip cpsi rhod rhoA rhomuR rhosigmamuR 
cphiR cphipinf cphiy cbeta ch sigmad sigmaA sigmamuR sigmasigmamuR ciotap

dSS ASS muRSS sigmasigmamuRSS RSS pinfSS ySS lSS cSS mcSS wSS margcSS;

cbeta=0.9945;
csigmac=1;
ctheta=1;
ch=0.75;
cepsilon=21;
cphip=236.1;
pinfSS=1.0045;
cphiR=0.81;
cphipinf=2.03;
cphiy=0.3;
ciotap=0.75;

rhod=0.18;
rhoA=0.95;
rhomuR=0.15;
rhosigmamuR=0.9;

sigmad=0.23;
sigmaA=0.45;
sigmamuR=0.24;
sigmasigmamuR=1;

dSS=1;
ASS=1;
muRSS=1;
sigmasigmamuRSS=1;
RSS=pinfSS/cbeta;
lSS=1/3;
ySS=ASS*lSS;
cSS=ySS;
mcSS=(cepsilon-1)/cepsilon;
wSS=mcSS*ASS;
margcSS=dSS*(1-cbeta*ch)/(((1-ch)*cSS)^csigmac);
cpsi=wSS*margcSS/(dSS*lSS^ctheta);
//-----------------------------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------------------------
model;
// marginal utility of consumption
exp(d)/((exp(c)-ch*exp(c(-1)))^csigmac)-cbeta*ch*exp(d(+1))/((exp(c(+1))-ch*exp(c))^csigmac)=exp(margc);

// labour supply
exp(w)*exp(margc)=cpsi*exp(d)*exp(l)^ctheta;

// euler equation
exp(margc)=cbeta*exp(margc(+1))*exp(R)/exp(pinf(+1));

// marginal cost
exp(mc)=exp(w)/exp(A);

// production function
exp(y)=exp(A)*exp(l);

// philips curve
cepsilon/(cepsilon-1)*exp(mc)
-cphip*((exp(pinf)/(pinfSS^(1-ciotap)*exp(pinf(-1))^ciotap)-1)
*exp(pinf)/(pinfSS^(1-ciotap)*exp(pinf(-1))^ciotap)
-cbeta*exp(margc(+1))/exp(margc)*exp(y(+1))/exp(y)
*(exp(pinf(+1))/(pinfSS^(1-ciotap)*exp(pinf)^ciotap)-1)
*exp(pinf(+1))/(pinfSS^(1-ciotap)*exp(pinf)^ciotap))=1;

// policy rule
exp(R)/RSS=(exp(R(-1))/RSS)^cphiR*(exp(pinf)/pinfSS)^(cphipinf*(1-cphiR))
*(exp(y)/ySS)^(cphiy*(1-cphiR))*exp(muR);

// market clearing condition
exp(y)=exp(c)+acp*exp(y);

// demand shock
d=rhod*d(-1)+sigmad*dshk;

// supply shokc
A=rhoA*A(-1)+sigmaA*Ashk;

// policy shock
muR=rhomuR*muR(-1)+exp(sigmaR)*muRshk;

// policy uncertainty
sigmaR=(1-rhosigmamuR)*log(sigmamuR)+rhosigmamuR*sigmaR(-1)+sigmasigmamuR*sigmaRshk;

// adjustment cost
acp=0.5*(exp(pinf)/(pinfSS^(1-ciotap)*exp(pinf(-1))^ciotap)-1)^2;

end;
//-----------------------------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------------------------
initval;
acp=0;
d=0;
A=0;
muR=0;
sigmaR=log(sigmamuR);
R=log(RSS);
pinf=log(pinfSS);
y=log(ySS);
l=log(lSS);
c=log(cSS);
mc=log(mcSS);
w=log(wSS);
margc=log(margcSS);
end;
//-----------------------------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------------------------
//resid;
//check;
//-----------------------------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------------------------
shocks;
var sigmaRshk = 1;
var dshk = 1;
var muRshk = 1;
var Ashk = 1;
end;
//---------------------------------------------------------------------
// 6. Run Dynare with pruning
//---------------------------------------------------------------------
resid;
check;
//-----------------------------------------------------------------------//
//-----------------------------------------------------------------------//
stoch_simul(order=3,irf=0,noprint,nograph,pruning,periods=10200,drop=10000) y pinf R;
