%% Housekeeping
close all
clear
clc
%% Load Dynare Model Information
dynare DsgeModel;
%% Calculate DSGE IRFs
iorder=3;
HORZ=19;
VarNames={'sigmaR';'y';'pinf';'R'};
VarsIndex=find_variable_indices(VarNames,cellstr(M_.endo_names));
e1=zeros(M_.exo_nbr,1);
e1(4,1)=1;
replic=500;
long=40;
drop=500;
DsgeIrfsA=irf(oo_.dr,e1,long,drop,replic,iorder);
DsgeIrfs=DsgeIrfsA(VarsIndex,1:HORZ);
%% Simulate Data
replic=1000;
T=200;
S=2000+T;
ex_=randn(S,M_.exo_nbr);
y0=oo_.steady_state;
SimData=zeros(length(VarNames)+1,T,replic);
iter=0;
for i = 1 : replic;
    ex_=randn(S,M_.exo_nbr);
    y_=simult_(y0,oo_.dr,ex_,iorder);
    simy=y_(VarsIndex,end-T+1:end);
    SimData(:,:,i)=[ex_(end-T+1:end,4)';y_(VarsIndex,end-T+1:end)];
end
%% Save
save PolicyUncertaintySimRes DsgeIrfs SimData